{Adapted from the C routine of the same name from Press et al., 1992}
procedure fdjac (n: integer; x, fvec: vector; var df: glnpbynp);

const
     nmax = 40;
     eps  = 1.0e-4;
var
    f      : vector;
    i, j   : integer;
    h,temp : double;

begin
    for j:= 1 to n do begin
        temp:= x[j];
        h:=eps*abs(temp);
        if (h = 0.0) then h:= eps;
        x[j]:= temp+h;
        h:= x[j] - temp;
        funcv(n, x, f);
        x[j]:= temp;
        for i:= 1 to n do df[i,j]:= (f[i]-fvec[i])/h;
    end;
end;
